#include "Oniguruma_stdafx.h"
#include "RegEx.h"
#include <ablib/IsKanji.h>

namespace Oniguruma{

ablib::string tmp_string;

RegEx::RegEx() : m_regex(NULL),m_iscompiled(false){
	m_region = ::onig_region_new();
}

RegEx::RegEx(const TCHAR *regt) : m_regex(NULL), m_region(NULL), m_iscompiled(false) {
	m_region = ::onig_region_new();
	Compile(regt);
}
RegEx::RegEx(const RegEx &obj) : m_regex(NULL),m_opt(obj.m_opt),m_iscompiled(obj.m_iscompiled){
	m_region = ::onig_region_new();
	if(obj.m_region)::onig_region_copy(m_region,obj.m_region);
	if(obj.m_iscompiled)Compile(obj.m_reg);
}
RegEx &RegEx::operator=(const RegEx &obj){
	m_opt = obj.m_opt;
	m_iscompiled = false;
	if(obj.m_region)::onig_region_copy(m_region,obj.m_region);
	if(obj.m_iscompiled)Compile(obj.m_reg);
	return *this;
}

RegEx::~RegEx(){
	if(m_regex)::onig_free(m_regex);
	if(m_region)::onig_region_free(m_region,1);
}


/** IvVݒD
* @param set ݒ肷IvV
	- "word" : P̌gpDftHgfalseD
	- "CaseSense" : 啶ʂDftHgtrueD
	- "zero_match" : 0̃}b`}b`ƌȂǂݒ肷DftHgtrueD
	- "use_regular" : K\gǂDftHgtrueD
* @param val true܂falseD
* @return trueCsfalseD
*/
bool RegEx::SetOpt(const TCHAR *set,bool val){
#define SETOPT(s) if(::lstrcmpi(_T( #s ),set) == 0){m_opt. ## s = val;return true;}
	SETOPT(CaseSense);
	SETOPT(word);
	SETOPT(zero_match);
	SETOPT(use_regular);
#undef SETOPT
	return false;
}


bool RegEx::Compile(const TCHAR *regt){
	const UChar *reg = reinterpret_cast<const UChar*>(regt);
	m_reg = regt;
	// OnigurumagȂꍇD
	if(!m_opt.use_regular){
		if(*regt == '\0'){
			m_iscompiled = false;
			return false;
		}
		m_iscompiled = true;
		if(m_opt.CaseSense){
			m_noregsearch.Compile(regt);
		}else{
			ablib::string r = regt;
			r.tolower();
			m_noregsearch.Compile(r);
		}
		return true;
	}
	// 
	m_iscompiled = false;
	if(m_regex)::onig_free(m_regex);

	m_errcode = ::onig_new(
		&m_regex,reg,reg + GetByteLen(regt),
		m_opt.GetOnigurumaOption(),
		ENCODE,SYNTAX,&m_err);
	m_iscompiled = (m_errcode == ONIG_NORMAL);
	return m_iscompiled;
}

bool RegEx::Match(const TCHAR *strt){
	m_match.ismatched = false;
	if(!m_iscompiled)return false;
	m_target = strt;
	// **Searchɂʏ팟
	if(!m_opt.use_regular){
		if(m_opt.word){
			// P̌D
			ablib::string s;
			const TCHAR *p;
			if(m_opt.CaseSense)p = strt;
			else{
				s = strt;
				s.tolower();
				p = s.c_str();
			}
			while(true){
				if(!m_noregsearch.Match(p))return false;
				const TCHAR *q = p + m_noregsearch.GetMatchPos();
				if(
					(q == strt || !IsEitango(*(q - 1))) &&
					!IsEitango(*(q + m_noregsearch.GetMatchLen()))
				){
					m_match.pos = Len2Byte(q - strt);
					m_match.len = Len2Byte(m_noregsearch.GetMatchLen());
					m_match.str = m_noregsearch.GetMatchStr();
					m_match.ismatched = true;
					return true;
				}else ++p;
			}
		}else{
			if(m_opt.CaseSense){
				if(m_noregsearch.Match(strt)){
					m_match.pos = Len2Byte(m_noregsearch.GetMatchPos());
					m_match.len = Len2Byte(m_noregsearch.GetMatchLen());
					m_match.str = m_noregsearch.GetMatchStr();
					m_match.ismatched = true;
					return true;
				}else return false;
			}else{
				ablib::string s = strt;s.tolower();
				if(m_noregsearch.Match(s)){
					m_match.pos = Len2Byte(m_noregsearch.GetMatchPos());
					m_match.len = Len2Byte(m_noregsearch.GetMatchLen());
					m_match.str = m_noregsearch.GetMatchStr();
					m_match.ismatched = true;
					return true;
				}else return false;
			}
		}
	}
	const UChar *str = reinterpret_cast<const UChar*>(strt);
	int bytelen = GetByteLen(strt);
	const UChar *strend = str + bytelen;
	if(m_opt.word){
		int targetstart = 0;
		while(true){
			// Ƃ肠
			::onig_region_free(m_region,0);
			m_errcode = ::onig_search(m_regex,str,strend,str + targetstart,strend,m_region,ONIG_OPTION_NONE);
			if(m_errcode == ONIG_MISMATCH)return false;
			// P`FbND
			int pos = m_region->beg[0];
			int endpos = m_region->end[0];
			if(
				(pos == 0 || !IsEitango(strt[Byte2Len(pos) - 1])) && 
				(endpos >= bytelen || !IsEitango(strt[Byte2Len(endpos)]))
			)
			{
				//ʂD
				m_match.pos = Byte2Len(m_region->beg[0]);
				m_match.len = Byte2Len(m_region->end[0] - m_region->beg[0]);
				m_match.str.assign(m_target,m_match.pos,m_match.len);
				break;
			}
#ifdef UNICODE
			targetstart = pos + 2;
#else
			targetstart = pos + 1;
#endif
		}
	}else{
		//ʏ팟
		::onig_region_free(m_region,0);
		m_errcode = ::onig_search(m_regex,str,strend,str,strend,m_region,ONIG_OPTION_NONE);
		if(m_errcode == ONIG_MISMATCH)return false;
		m_match.pos = Byte2Len(m_region->beg[0]);
		m_match.len = Byte2Len(m_region->end[0] - m_region->beg[0]);
		m_match.str.assign(m_target,m_match.pos,m_match.len);
	}
	m_match.ismatched = true;
	return true;
}

const TCHAR *RegEx::GetMatchStr(int i){
	if(!m_match.ismatched)return _T("");
	if(!m_opt.use_regular)return i == 0 ? m_noregsearch.GetMatchStr() : _T("");
	if(i < 0 || i >= m_region->num_regs)return _T("");
	tmp_string.assign(m_target,Byte2Len(m_region->beg[i]),Byte2Len(m_region->end[i] - m_region->beg[i]));
	return tmp_string.c_str();
}

const TCHAR *RegEx::GetMatchStr(const TCHAR *str){
	if(!m_opt.use_regular)return str;
	struct TagStr{
		TagStr() : isload(false){}
		bool isload;
		ablib::string str;
	};
	TagStr tags[10];
	tmp_string.reserve(::lstrlen(str));
	int n;
	const TCHAR *p = str,*q = p;
	tmp_string = _T("");
	while(*p){
#ifndef UNICODE
		if(ablib::IsKanji(*p))p = p + 2;
		else if(*p == '\\'){
#else
		if(*p == '\\'){
#endif
			++p;
			n = *p - '1';
			if(n >= 0 && n <= 9){
				tmp_string.append(q,0,p - q - 1);
				if(!tags[n].isload){
					tags[n].str = GetMatchStr(n + 1);
					tags[n].isload = true;
				}
				tmp_string += tags[n].str;
			}else if(*p == '\\'){
				tmp_string.append(q,0,p - q);
			}else if(*p == 'n'){
				tmp_string.append(q,0,p - q - 1);
				tmp_string += _T("\n");
			}else if(*p == 't'){
				tmp_string.append(q,0,p - q - 1);
				tmp_string += _T("\t");
			}else continue;
			++p;q = p;
		}else ++p;
	}
	tmp_string += q;
	return tmp_string.c_str();
}

ablib::string RegEx::Replace(const TCHAR *str,const TCHAR *getstr){
	if(!IsCompiled())return _T("");
	ablib::string rv;
	rv = _T("");rv.reserve(::lstrlen(str));
	while(*str && Match(str)){
		rv.append(str,0,GetMatchPos());
		rv += GetMatchStr(getstr);
		str += GetMatchPos() + GetMatchLen();
	}
	rv += str;
	return rv;
}

int RegEx::GetMatchLen(int i){
	if(!m_match.ismatched)return 0;
	if(m_opt.use_regular)return i == 0 ? m_noregsearch.GetMatchLen() : 0;
	if(i < 0 || i >= m_region->num_regs)return 0;
	return Byte2Len(m_region->end[i] - m_region->beg[i]);
}

int RegEx::GetMatchPos(int i){
	if(!m_match.ismatched)return 0;
	if(m_opt.use_regular)return i == 0 ? m_noregsearch.GetMatchPos() : 0;
	if(i < 0 || i >= m_region->num_regs)return 0;
	return Byte2Len(m_region->beg[i]);
}

const TCHAR *RegEx::GetVer(){
	const char *ver = ::onig_version();
#ifdef UNICODE
	int len = ::lstrlenA(ver);
	wchar_t *buf = new wchar_t[len + 1];
	int size = ::MultiByteToWideChar(CP_ACP,0,ver,len,buf,len);
	buf[size] = '\0';
	tmp_string = buf;
	delete[] buf;
#else
	tmp_string = ver;
#endif
	return tmp_string.c_str();
}

const TCHAR *RegEx::GetErrorMsg(){
	static UChar buf[ONIG_MAX_ERROR_MESSAGE_LEN];
	int errsize = ::onig_error_code_to_str(buf,m_errcode,m_err);
#ifdef UNICODE
	static wchar_t rv[ONIG_MAX_ERROR_MESSAGE_LEN];
	int size = ::MultiByteToWideChar(CP_ACP,0,reinterpret_cast<char*>(buf),errsize,rv,ONIG_MAX_ERROR_MESSAGE_LEN);
	rv[size] = '\0';
	return rv;
#else
	return reinterpret_cast<const char*>(buf);
#endif
}

}//namespace Oniguruma
