#ifndef __ABLIB_BMSEARCH_H__
#define __ABLIB_BMSEARCH_H__

namespace ablib{

/**
* BM@ɂ镶񌟍D
* ll͈̂ǂ܂˂͖̂}lło܂ˁi΁j
*/

/** D
*/
class BMSearch{
private:
#ifdef UNICODE
	static const int CHARS_NUM = 65536;
#else
	static const int CHARS_NUM = 256;
#endif
public:
	BMSearch(){}
	explicit BMSearch(const TCHAR *str){Compile(str);}
	explicit BMSearch(const ablib::string &str){Compile(str);}
	void Compile(const TCHAR *str){
		m_search = str;
		MakeTable(str,m_search.length(),m_table);
	}
	void Compile(const ablib::string &str){
		m_search = str;
		MakeTable(str.c_str(),m_search.length(),m_table);
	}
	bool Match(const TCHAR *str,size_t len){
		return (m_matchpos = Search(str,len,m_search.c_str(),m_search.length(),m_table)) != -1;
	}
	bool Match(const TCHAR *str){return Match(str,::lstrlen(str));}
	bool Match(const ablib::string &str){return Match(str.c_str(),str.length());}
	intptr_t GetMatchPos() const{return m_matchpos;}
	size_t GetMatchLen() const{return m_search.length();}
	const TCHAR *GetMatchStr() const{return m_search.c_str();}
	const TCHAR *GetSearchStr() const{return m_search.c_str();}
	static TCHAR *strstr(const TCHAR *str,const TCHAR *pattern){
		size_t table[CHARS_NUM];
		size_t plen = ::lstrlen(pattern);
		MakeTable(pattern,plen,table);
		size_t rv = Search(str,::lstrlen(str),pattern,plen,table);
		if(rv == -1)return NULL;else return const_cast<TCHAR*>(str + rv);
	}

private:

	ablib::string m_search;
	intptr_t m_matchpos;
	size_t m_table[CHARS_NUM];
	static void MakeTable(const TCHAR *str,size_t len,size_t table[]);
	static intptr_t Search(const TCHAR *target,size_t targetlen,const TCHAR *search,size_t searchlen,size_t table[]);
};

/** tD
*/
class BMRSearch{
private:
#ifdef UNICODE
	static const int CHARS_NUM = 65536;
#else
	static const int CHARS_NUM = 256;
#endif
public:
	BMRSearch(){}
	BMRSearch(const TCHAR *str){Compile(str);}
	void Compile(const TCHAR *str){
		m_search = str;MakeTable(str,m_search.length(),m_table);
	}
	void Compile(const ablib::string &str){
		m_search = str;MakeTable(str.c_str(),m_search.length(),m_table);
	}
	bool Match(const TCHAR *str,size_t len){
		return (m_matchpos = Search(str,len,m_search.c_str(),m_search.length(),m_table)) != -1;
	}
	bool Match(const TCHAR *str){return Match(str,::lstrlen(str));}
	bool Match(const ablib::string &str){return Match(str.c_str(),str.length());}
	intptr_t GetMatchPos() const{return m_matchpos;}
	size_t GetMatchLen() const{return m_search.length();}
	const TCHAR *GetMatchStr() const{return m_search.c_str();}
	static TCHAR *strrstr(const TCHAR *str,size_t searchlen,const TCHAR *pattern){
		size_t plen = ::lstrlen(pattern);
		size_t table[CHARS_NUM];
		MakeTable(pattern,plen,table);
		intptr_t rv = Search(str,searchlen,pattern,plen,table);
		if(rv == -1)return NULL;else return const_cast<TCHAR*>(str + rv);
	}
	static TCHAR *strrstr(const TCHAR *str,const TCHAR *pattern){
		return strrstr(str,::lstrlen(str),pattern);
	}

private:
	ablib::string m_search;
	intptr_t m_matchpos;
	size_t m_table[CHARS_NUM];
	static void MakeTable(const TCHAR *str,size_t len,size_t table[]);
	static intptr_t Search(const TCHAR *target,size_t targetlen,const TCHAR *search,size_t searchlen,size_t table[]);
};

}//namespace ablib


#endif //__ABLIB_BMSEARCH_H__

