#include "ablib.h"
#include "CmdLine.h"
#include "IsKanji.h"

namespace ablib{

void CmdLine::options::add(TCHAR opt,bool optarg){
	chararg[opt].needed = true;
	chararg[opt].needarg = optarg;
}

void CmdLine::options::add(const ablib::string &opt,bool optarg){
	strarg[opt].needed = true;
	strarg[opt].needarg = optarg;
}

/// ˁ[D
bool CmdLine::parse(){
	m_argv.clear();
	const TCHAR *p = m_arg.c_str();
	const TCHAR *q,*r;
	do{
		while(*p == ' ')++p;
		q = NextToken(p);
		r = q;
		if(!q)q = p + ::lstrlen(p);
		if(*p == '-' && *(p + 1) == '-'){
			//^IvV
			p += 2;
			ablib::string opt(p,q - p);
			DEBUGSTRING(_T("Arg : IvV%s"),opt.c_str());

			if(!m_options[opt].needed){
				m_errmsg = opt + _T("͒mȂIvVłD");
				return false;
			}
			m_options[opt].check = true;
			if(m_options[opt].needarg){
				while(*q == ' ')++q;
				p = q;
				q = NextToken(p);
				if(!q){
					m_errmsg = opt + _T("͈KvƂIvVłD");
					return false;
				}
				m_options[opt].arg.assign(p,q - p);
				DEBUGSTRING(_T("Arg : %s̈%s"),opt.c_str(),m_options[opt].arg.c_str());
			}
		}else if(*p == '-'){
			// PIvV
			++p;
			bool oneopt;//IvVH1͘A˂邯ǘA˂ꍇv͂ˁ[D
			if(*(p + 1) == '\0')oneopt = true;
			else oneopt = false;
			if(!m_options[*p].needed){
				m_errmsg = ablib::string(*p) + _T("͒mȂIvVłD");
				return false;
			}
			m_options[*p].check = true;
			if(m_options[*p].needarg){
				if(!oneopt){
					m_errmsg = ablib::string(*p) + _T("͈KvƂ܂D̃IvV͒P̂Ŏw肵ĂD");
					return false;
				}else{
					p = q;
					while(*p == ' ')++p;
					q = NextToken(p);
					if(!q){
						m_errmsg = ablib::string(*p) + _T("͈KvƂIvVłD");
						return false;
					}
					m_options[*p].arg.assign(p,q - p);
				}
			}
		}else{
			if(*p){
				m_argv.push_back(ablib::string(p,q - p));
				DEBUGSTRING(_T("Arg : u%sv"),p);
			}
		}
		while(*p == ' ')++p;
	}while(p = r);

	return true;
}

const TCHAR *CmdLine::NextToken(const TCHAR *p){
	bool dq = false;
	while(*p){
#ifndef UNICODE
		if(IsKanji(*p))p += 2;
		else
#endif
		if(*p == '\"'){
			dq = !dq;
			++p;
		}else if(!dq && *p == ' ')return p;
		else ++p;
	}
	return NULL;
}

}//namespace ablib

