#ifndef __ABLIB_LOCK_H__
#define __ABLIB_LOCK_H__

namespace ablib{

class Lock{
protected:
	Lock(){::InitializeCriticalSection(&m_csec);}
	Lock(const Lock &obj){::InitializeCriticalSection(&m_csec);}
	virtual ~Lock(){::DeleteCriticalSection(&m_csec);}
	Lock &operator=(const Lock &obj){::InitializeCriticalSection(&m_csec);return *this;}

	struct LOCK{
		LOCK(const Lock *me){
			m_pcsec = &(me->m_csec);
			::EnterCriticalSection(m_pcsec);
		}
		~LOCK(){::LeaveCriticalSection(m_pcsec);}
	private:
		CRITICAL_SECTION *m_pcsec;
		NOCOPY(LOCK);
	};

private:
	mutable CRITICAL_SECTION m_csec;
	friend struct LOCK;
};

}//namespace ablib

#endif //__ABLIB_LOCK_H__

