#ifndef __ABLIB_ALLOC_H__
#define __ABLIB_ALLOC_H__

#include <new>
#include "ablib.h"

namespace ablib{
/* Ƃ肠DnewdeleteǁD
*/

template<typename T>class allocator{
public:
	typedef size_t size_type;
	typedef T *pointer;
	typedef const T *const_pointer;
	typedef T &reference;
	typedef const T &const_reference;

	template<typename U>struct rebind{
		typedef allocator<U> other;
	};

	allocator(){};
	allocator(const allocator&){};
	~allocator(){};

//	size_type max_size() const throw(){return std::numeric_limits<std::size_t>::max() / sizeof(T);}

	pointer allocate(size_type Count,const void * = 0){return static_cast<pointer>(::operator new(Count * sizeof(T)));}

	void construct(pointer p,const T &val){new((void*)p)T(val);}
	void destroy(pointer p){p->~T();}

	void deallocate(pointer p,size_type = 0){::operator delete(static_cast<void*>(p));}

};

}

#endif //__ABLIB_ALLOC_H__

