#ifndef __ABLIB_FUNCTIONAL_H__
#define __ABLIB_FUNCTIONAL_H__

#include "ablib.h"

//functionalt@C班ƂĂB
namespace ablib{

template<class _Arg1,class _Arg2,class _Result>struct binary_function{
	typedef _Arg1 first_argument_type;
	typedef _Arg2 second_argument_type;
	typedef _Result result_type;
};


template<class _Ty>struct less : public binary_function<_Ty, _Ty, bool>{	// functor for operator<
	bool operator()(const _Ty& _Left, const _Ty& _Right) const{	// apply operator< to operands
		return (_Left < _Right);
	}
};

template<class _Ty>struct greater : public binary_function<_Ty, _Ty, bool>{	// functor for operator>
	bool operator()(const _Ty& _Left, const _Ty& _Right) const{	// apply operator> to operands
		return (_Left > _Right);
	}
};

template<class _Ty>struct greater_equal : public binary_function<_Ty, _Ty, bool>{	// functor for operator>=
	bool operator()(const _Ty& _Left, const _Ty& _Right) const{	// apply operator>= to operands
		return (_Left >= _Right);
	}
};

		// TEMPLATE STRUCT less_equal
template<class _Ty>struct less_equal : public binary_function<_Ty, _Ty, bool>{	// functor for operator<=
	bool operator()(const _Ty& _Left, const _Ty& _Right) const{	// apply operator<= to operands
		return (_Left <= _Right);
	}
};

}//namespace ablib;
#endif //__ABLIB_FUNCTIONAL_H__

