#ifndef __ABLIB_SET_H__
#define __ABLIB_SET_H__

#include "functional.h"
#include "ablib.h"

namespace ablib{

const int BLOCK_SIZE = 16;

/** 񕪖؂Ńf[^ǗD
* ꉞiteratorɂANZX\D̂Ƃ댃ᑬD
*/
template<typename T,typename Alloc = alocator<T> >class Tree{
public:
	typedef size_t size_type;
	Tree(){Init();}
	Tree(const Tree<T> &obj){Init();CopyTree(m_root,obj.m_root);}
	virtual ~Tree(){clean();};

	void clear(){clean();Init();};

	virtual void insert(const T &obj) = 0;

protected:
	struct Node{
		T element;
		Node *left;
		Node *right;
		Node *parent;
	};
	typedef Node *PNode;
	Node *m_root;

	void Init(){
		m_head = new MemNode;
		m_nownode = m_head;
		m_head->next = NULL;
		m_next = 0;
	}

	struct MemNode{
		Node node[BLOCK_SIZE];
		MemNode *next;
	}*m_head,*m_nownode;
	int m_next;

	Node *alloc(){
		if(m_next != BLOCK_SIZE - 1)return &((m_nownode->node)[m_next++]);
		else{
			MemNode *New = new MemNode;
			Node *rv = &((m_nownode->node)[m_next++]);
			m_nownode->next = New;
			New->next = NULL;
			m_next = 0;
			m_nownode = New;
			return rv;
		}
	}

	void clean(){
		MemNode *p = m_head,*q;
		while(p){
			q = p;
			p = p->next;
			delete q;
		}
		m_head = NULL;
		m_nownode = NULL;
		m_root = NULL;
	}

private:
	void CopyTree(Node *&to,const Node *&from){
		if(from)to = alloc();
		else return;
		to->element = from->element;to->right = from->right;
		to->left = from->left;to->parent = from->parent;
		if(from->right)CopyTree(to->right,from->right);
		if(from->left)CopyTree(to->left,from->left);
		return;
	}
	size_type m_num,m_memnum;
	Node *m_memnode;

public:
	class iterator{
	public:
		iterator(){m_data = NULL;}
		iterator(Node *&data){m_data = data;}
		~iterator(){};

		T &operator*(){static T rv;if(m_data)return m_data->element;else return rv;}

		iterator &operator++(){m_data = Next(m_data);return *this;}
		iterator operator++(int){iterator rv = *this;m_data = Next(m_data);return rv;}

		bool operator!=(const iterator &obj){return (m_data != obj.m_data);};
		bool operator==(const iterator &obj){return (m_data == obj.m_data);};

		iterator &operator=(const iterator &obj){m_data = obj.m_data;return *this;};

		T *operator->() const{return &(m_data->element);};

	private:
		Node *m_data;
		Node *Next(Node *data){
			if(data == NULL)return NULL;
			else if(data->right)return Min(data->right);
			else if(data->parent == NULL)return NULL;
			else if(data == data->parent->left)return data->parent;
			else{
				Node *p = data->parent;
				while(p->parent != NULL && p == p->parent->right)p = p->parent;
				if(p->parent == NULL)return NULL;
				else return p->parent;
			}
		}
		Node *Min(Node *data){
			if(data->left)return Min(data->left);
			else return data;
		}
	};

	iterator begin(){if(m_root == NULL)return iterator();Node *m = Min(m_root);return iterator(m);};
	iterator end(){return iterator();};
	
	Node *Min(Node *data){
		if(data->left)return Min(data->left);
		else return data;
	}


};

/*
multisetsetB
f[^ǗTreeɔCB
ꉞvf̒ǉ͏o(O)B
A폜oˁ[ccB
*/

template <typename T,typename Comp = less<T> ,typename Alloc = allocator<T> > class multiset : public Tree<T,Alloc>{
public:
	multiset(){Init();m_root = NULL;}
	multiset(const multiset<T,Comp> &obj){Tree<T>::Tree(obj);}
	~multiset(){Tree<T>::~Tree();}

	void insert(const T &obj){
		if(m_root)insert(m_root,obj);
		else{
			m_root = alloc();
			m_root->element = obj;
			m_root->left = m_root->right = m_root->parent = NULL;
		}
	}

private:
	void insert(Node *root,const T &obj){
		Comp compare;
		if(root == NULL)return;//NȂ悤ɃR[fBOׂ
//		if(obj == m_root->element.obj)return;//d͋Ȃ
		else if(compare(obj,root->element)){
			if(root->left)insert(root->left,obj);
			else{
				root->left = alloc();
				root->left->parent = root;
				root->left->right = root->left->left = NULL;
				root->left->element = obj;
			}
		}else{
			if(root->right)insert(root->right,obj);
			else{
				root->right = alloc();
				root->right->parent = root;
				root->right->left = root->right->right = NULL;
				root->right->element = obj;
			}
		}
		return;
	}
};

template <typename T,typename Comp = less<T>,typename Alloc = allocator<T> > class set : public Tree<T,Alloc>{
public:
	set(){Init();m_root = NULL;}
	set(const set<T,Comp> &obj){Tree<T>::Tree(obj);}
	~set(){Tree<T>::~Tree();}

	void insert(const T &obj){
		if(m_root)insert(m_root,obj);
		else{
			m_root = alloc();
			m_root->element = obj;
			m_root->left = m_root->right = m_root->parent = NULL;
		}
	}
	

private:
	void insert(Node *root,const T &obj){
		Comp compare;
		if(root == NULL)return;//NȂ悤ɃR[fBOׂ
		if(obj == root->element)return;//d͋Ȃ
		else if(compare(obj,root->element)){
			if(root->left)insert(root->left,obj);
			else{
				root->left = alloc();
				root->left->parent = root;
				root->left->right = root->left->left = NULL;
				root->left->element = obj;
			}
		}else{
			if(root->right)insert(root->right,obj);
			else{
				root->right = alloc();
				root->right->parent = root;
				root->right->left = root->right->right = NULL;
				root->right->element = obj;
			}
		}
		return;
	}
};




}//ablib

#endif //__ABLIB_SET_H__

