#ifndef __ABLIB_SMALLVECTOR_H__
#define __ABLIB_SMALLVECTOR_H__

namespace ablib{

/** ŒꒃȑfvectorNXD
* newȂłށD
* clearĂf[^͔j󂳂Ȃ̂ŒӁD
*/
template<typename T,int DEFAULT_MEMORYSIZE = 20> class SmallVector{
public:
	SmallVector() : m_asize(0),m_size(0),m_heapdata(NULL){}
	~SmallVector(){if(m_heapdata)delete[] m_heapdata;}
	void push_back(const T &obj){
		if(m_heapdata){
			if(m_size >= m_asize)Realloc();
			m_heapdata[m_size++] = obj;
		}else{
			if(m_size < DEFAULT_MEMORYSIZE)m_stackdata[m_size++] = obj;
			else{
				m_asize = 2*DEFAULT_MEMORYSIZE;
				m_heapdata = new T[m_asize];
				for(int i = 0 ; i < DEFAULT_MEMORYSIZE ; ++i)m_heapdata[i] = m_stackdata[i];
				m_heapdata[m_size++] = obj;
			}
		}
	}
	void clear(){m_size = 0;}
	bool erase(int i){
		if(i < 0 || i >= m_size)return false;
		T *arr = m_heapdata ? m_heapdata : m_stackdata;
		for(int j = i; j < m_size ; ++j)arr[j] = arr[j + 1];
		--m_size;
		return true;
	}
	int size() const{return m_size;}
	T &operator[](int i){return m_heapdata ? m_heapdata[i] : m_stackdata[i];}
	const T &operator[](int i)const{return m_heapdata ? m_heapdata[i] : m_stackdata[i];}

private:
	int m_size,m_asize;
	T *m_heapdata;
	T m_stackdata[DEFAULT_MEMORYSIZE];
	void Realloc(){
		T *New = new T[m_asize*2];
		for(int i = 0 ; i < m_size ; ++i)New[i] = m_heapdata[i];
		delete[] m_heapdata;
		m_heapdata = New;
		m_asize = m_asize * 2;
	}
};

}//namespace ablib

#endif //__ABLIB_SMALLVECTOR_H__

