#ifndef __ABLIB_STRING_H__
#define __ABLIB_STRING_H__

#include "ablib.h"
#include <iostream>
#include <string>

namespace ablib{

/** ^DO߂āCstd::string̔hɂ邱ƂɂD
*/

template<typename CH> class basic_string : public std::basic_string<CH>{
public:
	basic_string() : std::basic_string<CH>(){}
	~basic_string(){}
	basic_string(const basic_string<CH> &s) : std::basic_string<CH>(s){}
	basic_string(const CH *s) : std::basic_string<CH>(s){}
	basic_string(const std::basic_string<CH> &s) : std::basic_string<CH>(s){}
	basic_string(const CH *s,size_t size) : std::basic_string<CH>(s,size){}
	basic_string(const CH s) : std::basic_string<CH>(1,s){}
	template <typename Iter> basic_string(Iter first,Iter last) : std::basic_string<CH>(first,last){}

	const basic_string<CH> &toupper();
	const basic_string<CH> &tolower();

	size_type find(value_type ch, size_type off = 0) const;
	size_type find(const value_type *ch, size_type off = 0) const;
	size_type find(const value_type *ptr, size_type off, size_type count) const;
	size_type find(const basic_string<CH>& str, size_type off = 0) const;
	/*
	size_type rfind(value_type ch, size_type off = 0) const;
	size_type rfind(const value_type *ch, size_type off = 0) const;
	size_type rfind(const value_type *ptr, size_type off, size_type count) const;
	size_type rfind(const basic_string<CH>& str, size_type off = 0) const;
	*/
	// ɑSu{D
	int replace(const basic_string<CH> &search,const basic_string<CH> &replace){
		basic_string<CH> result;
		result.reserve(length() + 30);
		int rv = 0;
		size_type p = 0,q = 0;
		while((p = find(search,q)) != npos){
			++rv;
			result.append(*this,q,p - q);
			result += replace;
			q = p + search.length();
		}
		result.append(*this,q,npos);
		operator=(result);
		return rv;
	}
	
	static basic_string<CH> sprintf(const CH *format,...);
};

typedef basic_string<char> cstring;
typedef basic_string<wchar_t> wstring;
#ifdef UNICODE
typedef wstring string;
#else
typedef cstring string;
#endif


namespace TransCode{
basic_string<char> Trans(const basic_string<wchar_t> &str);
basic_string<wchar_t> Trans(const basic_string<char> &str);

#ifdef UNICODE
inline string FromChar(const char *buf){return Trans(basic_string<char>(buf));}
inline string FromChar(const basic_string<char> &buf){return Trans(buf);}
inline basic_string<char> ToChar(const wchar_t *buf){return Trans(basic_string<wchar_t>(buf));}
inline basic_string<char> ToChar(const string &buf){return Trans(buf);}
#else
inline string FromChar(const char *buf){return basic_string<char>(buf);}
inline string FromChar(const basic_string<char> &buf){return buf;}
inline basic_string<char> ToChar(const char *buf){return basic_string<char>(buf);}
inline basic_string<char> ToChar(const string &buf){return buf;}
#endif

}
}//namespace ablib

#endif //__ABLIB_STRING_H__

