#ifndef __ABLIB_VECTOR_H__
#define __ABLIB_VECTOR_H__

#include "ablib.h"
#include "alloc.h"

namespace ablib{

/** ȈՃxNgNXB
* 債Ƃ͏oȂB
*/

template<typename T,typename Alloc = ablib::allocator<T> > class vector
{
public:
	typedef size_t size_type;
	typedef T *pointer;
	typedef const T *const_pointer;
	typedef T *iterator;
	typedef const T *const_iterator;
	typedef T &reference;
	typedef const T &const_reference;

	vector(size_type size = 16,const T &val = T()) : m_alen(size) , m_len(0) , m_buf(m_alloc.allocate(size)){
		_Ufill(m_buf,size,val);
	};

	vector(const vector<T> &obj){
		T val = T();
		m_alen = obj.m_alen;m_len = obj.m_len;
		m_buf =m_alloc.allocate(m_alen);
		pointer p = _Ucopy(obj.m_buf,obj.m_buf + m_len,m_buf);
		_Ufill(p,m_alen - m_len,val);
	};

	~vector(){_Destroy(m_buf,m_buf + m_alen);m_alloc.deallocate(m_buf,0);};

	vector<T> &operator=(const vector<T> &obj){
		T val = T();
		_Destroy(m_buf,m_buf + m_alen);
		m_alloc.deallocate(m_buf);
		m_alen = obj.m_alen;m_len = obj.m_len;
		m_buf = m_alloc.allocate(m_alen);
		pointer p = _Ucopy(obj.m_buf,obj.m_buf + m_len,m_buf);
		_Ufill(p,m_alen - m_len,val);
		return *this;
	};

	T &operator[](size_type n){return m_buf[n];};
	const T &operator[](size_type n)const{return m_buf[n];};

	size_type size()const{return m_len;};

	iterator begin(){return m_buf;}
	iterator end(){return m_buf + m_len;}

	void insert(iterator p,size_type count,const T &val = T()){
		if(m_alen < m_len + count){
			int pp = p - begin();
			Realloc(2*(m_len + count));
			p = pp + begin();
		}
		copy(p,end(),p + count);
		for(iterator q = p;q < p + count ; ++q)*q = val;
		m_len += count;
	}

	iterator insert(iterator p,const T &val = T()){
		size_type n = p - begin();
		insert(p,1,val);
		return (begin() + n);
	}

	void push_back(const T &obj){
		if(m_len >= m_alen)Realloc(m_alen * 2);
		m_buf[m_len++] = obj;
	};

	void pop_back(){
		if(m_len != 0)--m_len;
	}

	void clear(){
		T val = T();
		_Destroy(m_buf,m_buf + m_alen);
		m_alloc.deallocate(m_buf);
		m_len = 0;m_alen = 16;
		m_buf = m_alloc.allocate(m_alen);
		_Ufill(m_buf,m_alen,val);
	};
	
	bool empty() const {return (m_len == 0);}
	
	T &back() const{return m_buf[m_len - 1];}

	iterator erase(iterator p){
		copy(p + 1,end(),p);
		--m_len;
		return p;
	}

	iterator erase(iterator first,iterator last){
		m_len = copy(last,end(),first) - begin();
		return first;
	}


private:
	T *m_buf;
	size_type m_len;
	size_type m_alen;
	Alloc m_alloc;

	void Realloc(size_type size){
		T val = T();
		T *New = m_alloc.allocate(size);
		pointer p = _Ucopy(m_buf,m_buf + m_len,New);
		_Ufill(p,size - m_len,val);
		_Destroy(m_buf,m_buf + m_alen);
		m_alloc.deallocate(m_buf);
		m_buf = New;
		m_alen = size;
		return;
	};

	void _Ufill(pointer p,size_type n,const T &val){
		for(; n > 0 ; --n, ++p)m_alloc.construct(p,val);
	}

	pointer _Ucopy(iterator first,iterator last,pointer p){
		for(; first != last ; ++first, ++p)m_alloc.construct(p,*first);
		return p;
	}

	void _Destroy(pointer first,pointer last){
		for(; first != last ; ++first)m_alloc.destroy(first);
	}

	iterator copy(iterator first,iterator last,iterator dest){
		if(first > dest){
			for(; first != last ; ++first, ++dest)*dest = *first;
			return dest;
		}else{
			int num = last - first;
			dest += num;
			if(num == 0)return dest;
			do{--last;--dest;*dest = *last;}while(last != first);
			return dest + num;
		}
	}

};

}//namespace ablib

#endif //__ABLIB_VECTOR_H__

