#ifndef __ABLIB_WINDOW_EDIT_COMMAND_H__
#define __ABLIB_WINDOW_EDIT_COMMAND_H__

#include "struct.h"

namespace ablib{
namespace window{
namespace edit{

class EditWnd;

/**
* operator(&EditWnd)ƐFXôłD
* CommnadfUCp^[Ƃ炵DD
*/
class Command{
public:
	virtual Command *operator()(EditWnd *ed) = 0;
};

/**
* }Dvɑ}D
* sR[hwo܂DA16ȓidlj
*/
class InsertCommand : public Command{
public:
	InsertCommand(POS pos,const ablib::string &str,const TCHAR *sep = _T("\n")) : m_pos(pos),m_str(str){
		::lstrcpy(m_sep,sep);
	};
	~InsertCommand(){};
	Command *operator()(EditWnd *ed);

private:
	POS m_pos;
	ablib::string m_str;
	TCHAR m_sep[16];
	NOCOPY(InsertCommand);
};

/**
* ő}Ƃ폜łD
*/
class DeleteCommand : public Command{
public:
	DeleteCommand(POS start,POS end) : m_start(start),m_end(end){};
	~DeleteCommand(){};
	Command *operator()(EditWnd *ed);

private:
	POS m_start,m_end;
	NOCOPY(DeleteCommand);
};

/**
* }{폜u
*/
class ReplaceCommand : public Command{
public:
	ReplaceCommand(POS start,POS end,const ablib::string &str,const TCHAR *sep = _T("\n")):
	m_start(start),m_end(end),m_str(str){
		::lstrcpy(m_sep,sep);		
	};
	~ReplaceCommand(){};
	Command *operator()(EditWnd *ed);
	
private:
	POS m_start,m_end;
	ablib::string m_str;
	TCHAR m_sep[16];
	NOCOPY(ReplaceCommand);
};

}//namespace edit
}//namespace window
}//namespace ablib

#endif//__ABLIB_WINDOW_EDIT_COMMAND_H__

