#include "edit.h"
#include "EditWnd.h"
#include "edit_const.h"

namespace ablib{
namespace window{

using namespace edit;

/*
͎̃bZ[WD
*/

bool EditWnd::OnChar(Window *wnd,TCHAR ch,int repeat){
	if(m_set.readonly)return true;
	if(ch == '\r')ch = '\n';
	if(ch >= ' ' || ch == '\n')if(m_set.overwrite)overwrite(ch);else insert(ch);
	return true;
}

bool EditWnd::OnKey(Window *wnd,bool isDown,UINT vk,int repeat){
	if(isDown){
		//ꂽ
		switch(vk){
		case VK_TAB    :if(!readonly())tab();				break;
		case VK_RIGHT  :CheckSelect();right();				break;
		case VK_LEFT   :CheckSelect();left();				break;
		case VK_UP     :CheckSelect();up();					break;
		case VK_DOWN   :CheckSelect();down();				break;
		case VK_DELETE :if(!readonly())Delete();			break;
		case VK_BACK   :if(!readonly())backspace();			break;
		case VK_INSERT :overwriteswitch();					break;
//		case VK_SHIFT  :if(!m_pos.IsBeginSel())beginsel();	break;
		case VK_PRIOR  :CheckSelect();prevpage();			break;
		case VK_NEXT   :CheckSelect();nextpage();			break;
		default        :									break;
		}
		return true;
	}else{
		//ꂽ
		switch(vk){
//		case VK_SHIFT  :endsel();break;
		default        :break;
		}
		return true;
	}
}

//ĂƁ[IMED
bool EditWnd::OnIME(Window *wnd){
	if(m_set.readonly)return true;
	ablib::string str;
	wnd->GetIME()->GetText(str);
	if(str.length() != 0)insert(str);
	return false;
}

//}EX
bool EditWnd::OnLButtonDown(Window *wnd,Mouse *mos,bool isDClick){
	if(selecting())escape();
	XY xy;
	xy.x = (mos->GetPos().x - LEFT_SPACE) / m_fontdata.avewidth + GetWindow()->GetHScrollBar()->GetPos();
	xy.y = (mos->GetPos().y - TOP_SPACE ) / TextHeight() + GetWindow()->GetVScrollBar()->GetPos();
	m_pos.CorrectXY(xy);
	m_pos.SetPos(m_buf.XYToPOS(xy));
	SetCaret(true);
	m_pos.BeginSel();
	mos->SetCapture();
	return true;
}

bool EditWnd::OnLButtonUp(Window *wnd,Mouse *mos){
	XY xy;
	xy.x = (mos->GetPos().x - LEFT_SPACE) / m_fontdata.avewidth + wnd->GetHScrollBar()->GetPos();
	xy.y = (mos->GetPos().y - TOP_SPACE ) / TextHeight() + wnd->GetVScrollBar()->GetPos();
	m_pos.CorrectXY(xy);
	m_pos.SetPos(m_buf.XYToPOS(xy));
	SetCaret(true);
	m_pos.EndSel();
	mos->ReleaseCapture();
	return true;
}

bool EditWnd::OnMouseMove(Window *wnd,Mouse *mos,int keyFlags){
	if(keyFlags & MK_LBUTTON){
		XY xy;
		xy.x = (mos->GetPos().x - LEFT_SPACE) / m_fontdata.avewidth + wnd->GetHScrollBar()->GetPos();
		xy.y = (mos->GetPos().y - TOP_SPACE ) / TextHeight() + wnd->GetVScrollBar()->GetPos();
		POS oldtop = m_pos.SelTop();
		POS oldend = m_pos.SelEnd();
		m_pos.CorrectXY(xy);
		m_pos.SetPos(m_buf.XYToPOS(xy));
		SetCaret(true);
		SetScroll();
		InvalidateSel(oldtop,oldend);
	}
	return true;
}

bool EditWnd::OnMouseWheel(Window *wnd,Mouse *mos,int delta){
	CheckSelect();
	if(delta < 0)down(- 3 * delta);
	else up(3 * delta);
	int oldpos = wnd->GetVScrollBar()->GetPos();
	wnd->GetVScrollBar()->SetPos(wnd->GetVScrollBar()->GetPos() - 3 * delta);
	if(oldpos != wnd->GetVScrollBar()->GetPos()){
		GetWindow()->ScrollWindow(0,(oldpos - wnd->GetVScrollBar()->GetPos()) * TextHeight());
		Rect rc = wnd->GetRect();
		if(oldpos > wnd->GetVScrollBar()->GetPos()){
			rc.top = TextHeight() * (oldpos - wnd->GetVScrollBar()->GetPos());
			rc.bottom = rc.top + TOP_SPACE;
		}else{
			rc.top = 0;
			rc.bottom = TOP_SPACE;
		}
		wnd->Invalidate(rc);
	}
	SetCaret(true);
	return true;
}

bool EditWnd::OnVScroll(Window *wnd,int dy){
	DEBUGSTRING(_T("ablib::window::EditWnd::OnVScroll : XN[ = %d"),dy);
	int oldpos = wnd->GetVScrollBar()->GetPos();
	if(dy != 0){
		wnd->GetVScrollBar()->SetPos(oldpos + dy);
		int pos = wnd->GetVScrollBar()->GetPos();
		if(::abs(oldpos - pos) < wnd->GetVScrollBar()->GetPage()){
			wnd->ScrollWindow(0,TextHeight() * (oldpos - pos));
			Rect rc = wnd->GetRect();
			if(oldpos > pos){
				rc.top = TextHeight() * (oldpos - pos);
				rc.bottom = rc.top + TOP_SPACE;
			}else{
				rc.top = 0;
				rc.bottom = TOP_SPACE;
			}
			wnd->Invalidate(rc);
		}else wnd->Invalidate();
	}
	return true;
}

bool EditWnd::OnHScroll(Window *wnd,int dx){
	DEBUGSTRING(_T("ablib::window::EditWnd::OnHScroll : XN[ = %d"),dx);
	int oldpos = wnd->GetHScrollBar()->GetPos();
	if(dx != 0){
		wnd->GetHScrollBar()->SetPos(oldpos + dx);
		int pos = wnd->GetHScrollBar()->GetPos();
		if(::abs(oldpos - pos) < wnd->GetHScrollBar()->GetPage()){
			wnd->ScrollWindow(m_fontdata.avewidth * (oldpos - pos),0);
			Rect rc = wnd->GetRect();
			if(oldpos > pos){
				rc.left = m_fontdata.avewidth * (oldpos - pos);
				rc.right = rc.left+ LEFT_SPACE;
			}else{
				rc.left = 0;
				rc.right = LEFT_SPACE;
			}
			wnd->Invalidate(rc);
		}else wnd->Invalidate();
	}
	return true;
}


}//namespace window
}//namespace ablib

