#include "edit.h"
#include "struct.h"
#include "hilight.h"
#include "../ablib/SmallVector.h"

namespace ablib{
namespace window{
namespace edit{

bool Hilight::AddHilightData(const TCHAR *keyword,int opt,int hilightpos){
	HilightData hd;
	if(opt & regular){
		if(!hd.reg.Compile(keyword))return false;
		hd.reg.SetOpt(_T("zero_match"),FALSE);
		if(opt & word)hd.reg.SetOpt(_T("word"),TRUE);
		else hd.reg.SetOpt(_T("word"),FALSE);
		if(opt & nocasesense)hd.reg.SetOpt(_T("CaseSense"),FALSE);
		else hd.reg.SetOpt(_T("CaseSense"),TRUE);
	}
	hd.word = keyword;
	hd.option = opt;
	hd.hilightpos = hilightpos;
	m_hilight.push_back(hd);
	return true;
}

bool Hilight::Match(const TCHAR *str,int i,SmallVector<PosLen> &result){
	if(i < 0 || i >= m_hilight.size())return false;
//	result.erase(result.begin(),result.end());
	result.clear();
	if(m_hilight[i].option & regular){
		//K\
		if(!m_hilight[i].reg.Match(str))return false;
		result.push_back(PosLen(m_hilight[i].reg.GetMatchPos(),m_hilight[i].reg.GetMatchLen()));
		if(m_hilight[i].option & line){
			//s̋̎0`str̒
			result.push_back(PosLen(0,::lstrlen(str)));
			return true;
		}
		for(int j = 0,hpos = 1 ; j < m_hilight[i].reg.GetTokenNum() ; ++j,hpos <<= 1){
			if(m_hilight[i].hilightpos & hpos){
				PosLen db = PosLen(m_hilight[i].reg.GetMatchPos(j),m_hilight[i].reg.GetMatchLen(j));
				result.push_back(PosLen(m_hilight[i].reg.GetMatchPos(j),m_hilight[i].reg.GetMatchLen(j)));
			}
		}
		return true;
	}else{
		//ʏ팟
		return false;
	}
}

}//namespace edit
}//namespace window
}//namespace ablib