#ifndef __ABLIB_WINDOW_EDIT_LAYOUT_H__
#define __ABLIB_WINDOW_EDIT_LAYOUT_H__

//#include "../../ablib/vector.h"
#include <vector>
#include "Memory.h"
#include "struct.h"

namespace ablib{
namespace window{
namespace edit{

/**
* CAEgǗD܂ԂƂD
*/
class Layout{
public:
	Layout(Memory *m) : m_memory(m){};
	~Layout(void){};
	void SetTabSize(int tab){m_tabsize = (tab > 0 ? tab : 1);}
	void SetMaxX(int x){m_maxx = (x > 0 ? x : 1);}

	LayoutData GetLayoutData(int y) const{return m_layout[y];}
	int GetLayoutLineCount() const{return m_layout.size();}
	int LineToY(int line) const{return m_linetoy[line];}
	int YToLine(int y) const{return m_layout[y].line;}

	POS XYToPOS(XY xy);
	XY POSToXY(POS pos);

	void Clear(){m_layout.clear();m_linetoy.clear();}
	void DoLayout(int startline,int oldend,int newend);
	void DoLayout(int startline,int oldend){DoLayout(startline,oldend,m_memory->GetLineCount());}
	int GetMaxLength() const{return m_maxx;}

private:
	std::vector<int> m_linetoy;
	std::vector<LayoutData> m_layout;

	Memory *m_memory;
	int m_maxx,m_tabsize;

	void DUMP();

	NOCOPY(Layout);
};

}//namespace edit
}//namespace window
}//namespace ablib

#endif //__ABLIB_WINDOW_EDIT_LAYOUT_H__

