#ifndef __ABLIB_WINDOW_EDIT_REDOUNDO_H__
#define __ABLIB_WINDOW_EDIT_REDOUNDO_H__

//#include "../../ablib/list.h"
#include "../ablib/function.h"
#include <list>
#include "Command.h"

namespace ablib{
namespace window{
namespace edit{

class EditWnd;

/**
* 蒼CƁC蒼̂蒼DUndoRedoƌˁD
* CommandfUCp^[Ƃ̂ŏoDD
* yȂ̂ōXṼ`FbNƍXV̒ʒmɓD
*/

class RedoUndo
{
private:
	//f[^ێiSj
	struct Node{
		Node(Command *c,Node *p,Node *n) : cmd(c),prev(p),next(n){};
		Node() : cmd(NULL),prev(NULL),next(NULL){};
		~Node(){delete cmd;}
		Command *cmd;
		Node *prev;
		Node *next;
		void SetCmd(Command *c){delete cmd;cmd = c;}
	};
	void DUMP(const TCHAR *done);

public:
	RedoUndo(void) : m_max(20),m_size(0),m_hist(NULL),m_head(NULL),m_updated(0){};
	~RedoUndo(void){Clear(m_head);}
	void AddUndoHist(Command *cmd);
	bool Undo(ablib::window::edit::EditWnd *ed);
	bool Redo(ablib::window::edit::EditWnd *ed);
	void SetMax(int max);
	void Clear(){Clear(m_head);m_hist = NULL;}
	bool Updated() const{return (m_updated != 0);}
	void ResetUpdated(){m_updated = 0;}

private:
	int m_max;
	int m_size;
	//UndoɎsDRedo͎D
	Node *m_hist;
	//wbhD
	Node *m_head;
	void Clear(Node *start);
	//XVȂm_updated == 0
	int m_updated;

	NOCOPY(RedoUndo);
};

}//namespace edit
}//namespace window
}//namespace ablib

#endif //__ABLIB_WINDOW_EDIT_REDOUNDO_H__

