#ifndef __ABLIB_WINDOW_EDIT_SEARCH_H__
#define __ABLIB_WINDOW_EDIT_SEARCH_H__

#include "RegEx_Def.h"
#include "struct.h"
#include "editbuf.h"

namespace ablib{
namespace window{
namespace edit{

/**
* e팟DUI͑ŎĂD
*/

class Search{
public:
	Search(EditBuf *buf) : m_buf(buf),m_searchopt(0){};
	Search() : m_buf(NULL),m_searchopt(0){};
	~Search(){};

	int SearchDown(const ablib::string &str,const ablib::string &flag,POS &result);
	int SearchUp(const ablib::string &str,const ablib::string &flag,POS &result);

	bool SetSearch(const ablib::string &str,int flag);
	bool SetSearch(const ablib::string &st,const ablib::string &flag);

	int FindDown(POS &result);
	int FindUp(POS &result);

	ablib::string GetFindStr(){m_findstr;}
	ablib::string GetReplaceStr(const ablib::string &getstr);

	int SearchOption() const{return m_searchopt;}
	ablib::string SearchOptionStr();
	ablib::string SearchBuffer() const{return m_searchbuf;}

	void SetRange(POS start,POS end){m_start = start;m_end = end;}

private:
	struct FindLineData{
		int pos;
		int length;
	};
	void AnalyzeFlag(const ablib::string &flag);

	FindLineData FindLineDown(const ablib::string &str);
	FindLineData FindLineDownReg(const ablib::string &str);
	FindLineData FindLineUp(const ablib::string &str);
	FindLineData FindLineUpReg(const ablib::string &str);

	int FindDownHelper(POS &result);
	int FindUpHelper(POS &result);

	bool IsEitango(TCHAR c){return (('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z') || (c == '_'));}

	ablib::string m_searchbuf;
	ablib::string m_findstr;
	int m_searchopt;
	ABLIB_WINDOW_EDIT_REGEX m_reg;
	EditBuf *m_buf;
	POS m_start,m_end;

	NOCOPY(Search);
};

}//namespace edit
}//namespace window
}//namespace ablib

#endif//__ABLIB_WINDOW_EDIT_SEARCH_H__

