#ifndef __ABLIB_SYSTEM_FILE_H__
#define __ABLIB_SYSTEM_FILE_H__

#include "time.h"
#include "ablib_system.h"

/** t@C擾CD
* ̂Ƃ뎞Ԃ΂cc
*/

namespace ablib{
namespace system{

class File
{
public:
	File(){}
	~File(){}
	static DWORD GetSize(const TCHAR *file);
	static DWORD GetSize(const ablib::string &f){return GetSize(f.c_str());}
	static Time GetLastWriteTime(const TCHAR *file);
	static Time GetLastWriteTime(const ablib::string &f){return GetLastWriteTime(f.c_str());}
	static Time GetLastAccessTime(const TCHAR *file);
	static Time GetLastAccessTime(const ablib::string &f){return GetLastAccessTime(f.c_str());}
	static Time GetCreationTime(const TCHAR *file);
	static Time GetCreationTime(const ablib::string &f){return GetCreationTime(f.c_str());}

	static bool SetLastWriteTime(const TCHAR *file,const Time &t);
	static bool SetLastWriteTime(const ablib::string &f,const Time &t){return SetLastWriteTime(f.c_str(),t);}
	static bool SetLastAccessTime(const TCHAR *file,const Time &t);
	static bool SetLastAccessTime(const ablib::string &f,const Time &t){return SetLastAccessTime(f.c_str(),t);}
	static bool SetCreationTime(const TCHAR *file,const Time &t);
	static bool SetCreationTime(const ablib::string &f,const Time &t){return SetCreationTime(f.c_str(),t);}
	
	static bool IsExist(const TCHAR *file){return (::GetFileAttributes(file) != -1);}
	static bool IsExist(const ablib::string &f){return IsExist(f.c_str());}

	static bool DeleteFiles(const ablib::string &dir);
};

}//namespace system
}//namespace ablib

#endif //__ABLIB_SYSTEM_FILE_H__

