#include "ablib_system.h"
#include "stay.h"

namespace ablib{
namespace system{

bool Stay::Start(){
	if(m_event)return false;
	HANDLE e = ::CreateEvent(NULL,TRUE,FALSE,m_keyname.c_str());
	if(e == NULL || ::GetLastError() == ERROR_ALREADY_EXISTS){SetLastError();return false;}
	m_event = e;
	return true;
}

bool Stay::CheckStop(int time){
	DWORD d = ::WaitForSingleObject(m_event,time * 1000);
	if(d == WAIT_OBJECT_0 || d == WAIT_ABANDONED)return true;
	else return false;
}

Stay::state Stay::CheckStopWithMsgLoop(int time){
	DWORD d = ::MsgWaitForMultipleObjects(1,&m_event,FALSE,time * 1000,QS_ALLEVENTS | QS_SENDMESSAGE | QS_ALLPOSTMESSAGE);
	switch(d){
	case WAIT_OBJECT_0:		return stop;
	case WAIT_OBJECT_0 + 1:	return msg;
	default:				return timeout;
	}
}

bool Stay::Stop(){
	HANDLE e = ::OpenEvent(EVENT_ALL_ACCESS,TRUE,m_keyname.c_str());
	if(e == NULL){SetLastError();return false;}
	::SetEvent(e);
	return true;
}

}//namespace system
}//namespace ablib
