#include "ablib_window.h"
#include "Basedlg.h"

namespace ablib{
namespace window{


Dialog *BaseDlg::Create(Wnd *parent,LPCTSTR id){
	if(m_window)return NULL;
	::CreateDialogParam(m_appint,id,parent ? parent->GetHWND() : NULL,sDlgProc,reinterpret_cast<LPARAM>(this));
	return m_window;
}

void BaseDlg::AddSubClass(SubClassDlg *sub,int id){
	m_subclass.push_back(SubClassData(sub,id));
	if(m_window){
		unsigned int i = m_subclass.size() - 1;
		m_subclass[i].hwnd = ::GetDlgItem(m_window->GetHWND(),id);
		m_subclass[i].subclass->SubClass(m_subclass[i].hwnd);
	}
}
void BaseDlg::AddSubClass(SubClassDlg *sub,HWND hwnd){
	m_subclass.push_back(SubClassData(sub,hwnd));
	if(m_window){
		unsigned int i = m_subclass.size() - 1;
		m_subclass[i].subclass->SubClass(m_subclass[i].hwnd);
	}
}


INT_PTR CALLBACK BaseDlg::sDlgProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam){
	BaseDlg *target = static_cast<BaseDlg*>(::GetProp(hwndDlg,_T("ABENORI_WINDOW_PROP")));
	if(!target){
		if(uMsg == WM_INITDIALOG)target = reinterpret_cast<BaseDlg*>(lParam);
		if(target){
			target->Atach(hwndDlg);
			target->m_window = new Dialog(hwndDlg);
			for(int i = 0 ; i < target->m_subclass.size() ; ++i){
				if(target->m_subclass[i].id != 0)target->m_subclass[i].hwnd = ::GetDlgItem(hwndDlg,target->m_subclass[i].id);
				target->m_subclass[i].subclass->SubClass(target->m_subclass[i].hwnd);
			}
		}
	}
	if(target){
		Dialog *me = target->GetWindow();
		if(!me)return FALSE;
		switch(uMsg){
		case WM_INITDIALOG:	return target->OnInitDialog(me) ? TRUE : FALSE;
		case WM_CLOSE:		return target->OnClose(me) ? TRUE : FALSE;
		case WM_DESTROY:
		{
			bool rv;
			if(rv = target->OnDestroy(me))target->Detach(hwndDlg);
			delete target->m_window;
			target->m_window = NULL;
			for(int i = 0 ; i < target->m_subclass.size() ; ++i){
				target->m_subclass[i].subclass->UnSubClass();
			}
			if(target->m_stopmsgloop)::PostQuitMessage(0);
			return rv ? TRUE : FALSE;
		}
		case WM_NOTIFY:
		{
			LRESULT rv = TRUE;
			if(target->OnNotify(me,reinterpret_cast<NMHDR*>(lParam),rv)){
//				::SetWindowLong(hwndDlg,DWL_MSGRESULT,rv);
				return rv;
			}else return FALSE;
		}
		case WM_SIZE:	return target->OnSize(me,wParam,LOWORD(lParam),HIWORD(lParam)) ? TRUE : FALSE;
		case WM_COMMAND:	return target->OnCommand(me,static_cast<int>(LOWORD(wParam)),static_cast<int>(HIWORD(wParam))) ? TRUE : FALSE;
		default:			return target->OnOtherMessage(me,uMsg,wParam,lParam) ? TRUE : FALSE;
		}
	}else return 0;
}



}//namespace window
}//namespace ablib