#include "ablib_window.h"
#include "SubClassWnd.h"

namespace ablib{
namespace window{

void SubClassDlg::SubClass(HWND hwnd){
	m_oldproc = reinterpret_cast<WNDPROC>(::SetWindowLongPtr(hwnd,GWLP_WNDPROC,reinterpret_cast<LONG_PTR>(sDlgProc)));
//	::SetProp(hwnd,_T("ABENORI_WINDOW_PROP_PROC"),reinterpret_cast<HANDLE>(m_oldproc));
	Atach(hwnd);
	m_dialog = std::shared_ptr<Dialog>(new Dialog(hwnd));
}

void SubClassDlg::UnSubClass(){
	if(m_dialog.get()){
		::SetWindowLongPtr(m_dialog->GetHWND(),GWLP_WNDPROC,reinterpret_cast<LONG_PTR>(m_oldproc));
		Detach(m_dialog->GetHWND());
		m_dialog.reset();
	}
}

INT_PTR CALLBACK SubClassDlg::sDlgProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam){
	SubClassDlg *target = static_cast<SubClassDlg*>(::GetProp(hwndDlg,_T("ABENORI_WINDOW_PROP")));
	if(target){
		Dialog *me = target->m_dialog.get();
		if(!me)return ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		
		{
			INT_PTR rv;
			if(target->PreTranslateMessage(me,uMsg,wParam,lParam,rv))return rv;
		}
		
		switch(uMsg){
		case WM_INITDIALOG:	return target->OnInitDialog(me) ? TRUE : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		case WM_CLOSE:		return target->OnClose(me) ? TRUE : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		case WM_DESTROY:	return target->OnDestroy(me) ? TRUE : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		case WM_SETFOCUS:
		{
			Dialog w(reinterpret_cast<HWND>(wParam));
			return target->OnSetFocus(me,&w) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_KILLFOCUS:
		{
			Dialog w(reinterpret_cast<HWND>(wParam));
			return target->OnKillFocus(me,&w) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_MOUSEMOVE:
		{
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnMouseMove(me,&m,static_cast<int>(wParam)) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_LBUTTONDOWN:
		{
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnLButtonDown(me,&m,false) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_LBUTTONDBLCLK:
		{	
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnLButtonDown(me,&m,true) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_LBUTTONUP:
		{
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnLButtonUp(me,&m) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_RBUTTONDOWN:
		{		
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnRButtonDown(me,&m,false) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_RBUTTONDBLCLK:
		{
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnRButtonDown(me,&m,true) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_RBUTTONUP:
		{
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnRButtonUp(me,&m) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_MBUTTONDOWN:
		{
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnMButtonDown(me,&m,false) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_MBUTTONDBLCLK:
		{
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnMButtonDown(me,&m,true) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_MBUTTONUP:
		{
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnMButtonUp(me,&m) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_MOUSEWHEEL:
		{
			Mouse m(hwndDlg,Point(static_cast<int>(static_cast<short>(LOWORD(lParam))),static_cast<int>(static_cast<short>(HIWORD(lParam)))));
			return target->OnMouseWheel(me,&m,static_cast<short>(HIWORD(wParam)) / WHEEL_DELTA) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		case WM_KEYDOWN:		return target->OnKey(me,true,static_cast<UINT>(wParam),static_cast<int>(LOWORD(lParam))) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		case WM_KEYUP:			return target->OnKey(me,false,static_cast<UINT>(wParam),static_cast<int>(LOWORD(lParam))) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		case WM_CHAR:			return target->OnChar(me,static_cast<TCHAR>(wParam),static_cast<int>(LOWORD(lParam))) ? 0 : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		case WM_COMMAND:	return target->OnCommand(me,static_cast<int>(LOWORD(wParam)),static_cast<int>(HIWORD(wParam))) ? TRUE : ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		case WM_NOTIFY:
		{
			LRESULT rv = TRUE;
			if(target->OnNotify(me,reinterpret_cast<NMHDR*>(lParam),rv)){
//				::SetWindowLong(hwndDlg,DWL_MSGRESULT,rv);
				return rv;
			}else return ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
		}
		default:			return target->OnOtherMessage(me,uMsg,wParam,lParam);
		}
//	}else return ::CallWindowProc(target->m_oldproc,hwndDlg,uMsg,wParam,lParam);
	}else return FALSE;
}
	




}//namespace window
}//namespace ablib

