#include "ablib_window.h"
#include "window.h"
#include "TaskTray.h"

namespace ablib{
namespace window{

bool TaskTray::Set(Wnd *wnd, HICON hicon, UINT Callbackmsg, const TCHAR *msg, UINT id){
	if(!wnd)return false;
	m_hwnd = wnd->GetHWND();
	NOTIFYICONDATA notif;

	notif.cbSize = sizeof(NOTIFYICONDATA);
	notif.hWnd = m_hwnd;
	notif.uID = id;
	notif.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	notif.uCallbackMessage = Callbackmsg;
	notif.hIcon = hicon;
	::lstrcpy(notif.szTip,msg);

	return Shell_NotifyIcon(NIM_ADD, &notif) ? true  : false;
}

void TaskTray::Destroy(){
	NOTIFYICONDATA notif;
	::ZeroMemory(&notif,sizeof(NOTIFYICONDATA));

	notif.cbSize = sizeof(NOTIFYICONDATA);
	notif.hWnd = m_hwnd;

	Shell_NotifyIcon(NIM_DELETE, &notif);
}

}//namespace window
}//namespace ablib