#include "zlib_stdafx.h"
#include "../window/dialog.h"
#include "../ablib/IsKanji.h"
#include "../system/File.h"
#include "zip.h"
#include "unzip.h"

namespace zlib{

namespace{
	struct{
		bool operator()(const TCHAR *msg){return true;};
	}DefaultMsgFunc;
}

Zip::Zip() : m_msgfunc(DefaultMsgFunc){}

bool Zip::CreateDirectoryReflex(const TCHAR *path){
	TCHAR *q = new TCHAR[::lstrlen(path) + 2],*p;
	::lstrcpy(q,path);
#ifdef UNICODE
	for(p = q ; *p ; ++p){
#else
	for(p = q ; *p ; p += ablib::IsKanji(*p) ? 2 : 1){
#endif
		if(*p == '\\'){
			*p = '\0';
			if(ablib::system::File::IsExist(q) == false && ::CreateDirectory(q,NULL) == FALSE){
				delete[] q;
				return false;
			}
			*p = '\\';
		}
	}
	delete[] q;
	return true;
}


bool Zip::DeCompress(const TCHAR *fname,const TCHAR *d){
	{LOCK l(this);m_stop = false;}
	ablib::string file;
	ablib::string dir = d;
	if(dir.rfind(_T("\\")) != dir.length() - 1)dir += _T("\\");
	unzFile Unzip = unzOpen(ablib::TransCode::ToChar(fname).c_str());
	if(!Unzip)return false;

	do {
		char Confname[512];
		unz_file_info fileinfo;
		if(unzGetCurrentFileInfo(Unzip,&fileinfo,Confname,sizeof(TCHAR) * 512,NULL,0,NULL,0) != UNZ_OK)break;

		int len = strlen(Confname);
		for (int i = 0; i < len; i = i + (ablib::IsKanji(Confname[i])?1:0) + 1){
			if(Confname[i] == '/')Confname[i] = '\\';
		}

		// fBNg̏ꍇ
		int yen = -1;
		for(int i = 0 ; i < len ; i = i + 1 + (ablib::IsKanji(Confname[i])?1:0)){
			if(Confname[i] == '\\')yen = i;
		}
		if(yen == len - 1)CreateDirectoryReflex(dir + ablib::TransCode::FromChar(Confname));

		// t@C̏ꍇ
		if(unzOpenCurrentFile(Unzip) != UNZ_OK)break;
		file = dir + ablib::TransCode::FromChar(Confname);
		CreateDirectoryReflex(file);
		m_msgfunc(ablib::TransCode::FromChar(Confname).c_str());
		{LOCK l(this);if(m_stop)return false;}
		HANDLE File = CreateFile(file.c_str(), GENERIC_READ | GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
		BYTE buf[62768];
		DWORD ReadSize;
		while ((ReadSize = unzReadCurrentFile(Unzip, buf, sizeof(BYTE) * 8192)) > 0){
			WriteFile(File,buf,ReadSize,&ReadSize,NULL);
			{LOCK l(this);if(m_stop)return false;}
		}
		FlushFileBuffers(File);
		CloseHandle(File);
		unzCloseCurrentFile(Unzip);
	}while(unzGoToNextFile(Unzip) != UNZ_END_OF_LIST_OF_FILE);
	unzClose(Unzip);
	return true;
}

}

